#!/usr/bin/php
<?php
/**
 * fsl2006 congress
 * topic: PHP router in Asterisk
 * author: Moises Silva <moy@ivsol.net>
 * @package fsl-astrouter
 */

/**
 * simple and hard coded router
 * of calls. Only support 3 hard coded
 * patterns (IAX exten, SIP exten and Zap channel)
 * 3X IAX
 * 2X SIP
 * XXXXXXXX Zap
 */
require_once 'AgiConnector.php';
$connector = new AgiConnector();
$connector->Write('Starting Router');
$connector->Write('you have dialed: ' . $connector->GetAgiVariable('extension'));
$dialed_number = $connector->GetAgiVariable('extension');
if ( FALSE !== ereg('^3[0-9]$', $dialed_number) )
{
	$channel = 'IAX';
}
elseif ( FALSE !== ereg('^2[0-9]$', $dialed_number) )
{
	$channel = 'SIP';
}
elseif ( FALSE !== ereg('^[0-9]{8}$') )
{
	$channel = 'Zap/1';
}
$connector->Dial($channel . "/" . $dialed_number);
?>
