<?php
/**
 * fsl2006 congress
 * topic: PHP router in Asterisk
 * author: Moises Silva <moy@ivsol.net>
 * @package fsl-astcallmanager
 */
/**
 * sample web page to show how to do
 * a click to dial application
 */

/* dont stop the process */
ignore_user_abort();

/* send any output directly to the browser*/
ob_implicit_flush();

/* define the destiny channel and other necessary data */
define('SALES_SIP_CHANNEL', 'SIP/33');
define('ZAP_CONTEXT', 'localline');
define('ZAP_PRIORITY', 1);
define('MANAGER_USER', 'fsl');
define('MANAGER_SECRET', 'junio2006');
print <<<TOP
<html>
<head>
<title>Click To Dial!</title>
</head>
<body>
TOP;
if ( isset($_POST['number']) && is_numeric($_POST['number']) )
:
	$number = $_POST['number'];
	/* open the manager socket */
	$manager_socket = fsockopen('localhost', 5038);
	if ( is_resource($manager_socket) )
	:
		/* read the Asterisk welcome message */
		$welcome = fread($manager_socket, 1024);
		/* Write Login Action data in several steps for clarity */
		fwrite($manager_socket, "Action: Login\r\n");
		fwrite($manager_socket, "Username: " . MANAGER_USER . "\r\n");
		fwrite($manager_socket, "Secret: " . MANAGER_SECRET . "\r\n");
		fwrite($manager_socket, "\r\n");
		/* read login response */
		$response       = fread($manager_socket, 1024);
		/* check if authentication was successfull */
		if ( FALSE !== stripos($response, "Success") )
		:
			/* send Originate Action */
			print "Originating call...<br />";
			fwrite($manager_socket, "Action: Originate\r\n");
			fwrite($manager_socket, "Channel: " . SALES_SIP_CHANNEL . "\r\n");
			fwrite($manager_socket, "Context: " . ZAP_CONTEXT . "\r\n");
			fwrite($manager_socket, "Exten: " . $number . "\r\n");
			fwrite($manager_socket, "Priority: " . ZAP_PRIORITY . "\r\n");
			fwrite($manager_socket, "\r\n");
			$response = fread($manager_socket, 1024);
			if ( FALSE !== stripos($response, "Success") )
			:
				print 'The call has been made. Please wait a few seconds.';
			else
			:
				print 'Service Currently Unavailable';
			endif;
		/* Failed Login, print error message */
		else
		:
			print 'Service Currently Unavailable';
		endif;
	/* unable to open socket, print error string */
	else
	:
		print 'Service Currently Unavailable';
	endif;
else
:
	print <<<FORM
	<form name="clicktodial" method="post" action="click_to_dial.php">
		<input type="text" name="number" /><br />
		<input type="submit" value="Click To Dial">
	</form>
	</body>
	</html>
FORM;
endif;
?>
