<?php
/**
 * fsl2006 congress
 * topic: PHP router in Asterisk
 * author: Moises Silva <moy@ivsol.net>
 * @package fsl-astcallmanager
 */

/**
 * open a socket to manager, read the welcome message
 * from Asterisk, put Ping Action data, read the response
 * and exit
 */
$errno          = -1;
$errstr         = '';
/* open the manager socket */
$manager_socket = fsockopen('localhost', 5038, $errno, $errstr);
if ( is_resource($manager_socket) )
{
	/* read the Asterisk welcome message */
	$welcome        = fread($manager_socket, 1024);
	print $welcome . "\n";

	/* Write Login Action data in several steps for clarity */
	fwrite($manager_socket, "Action: Login\r\n");
	fwrite($manager_socket, "Username: fsl\r\n");
	fwrite($manager_socket, "Secret: junio2006\r\n");
	fwrite($manager_socket, "\r\n");

	/* read login response */
	$response       = fread($manager_socket, 1024);
	print $response . "\n";

	/* check if authentication was successfull */
	if ( stripos($response, "Success") )
	{
		fwrite($manager_socket, "Action: Ping\r\n\r\n");
		$response = fread($manager_socket, 1024);
		print $response;
	}	
	/* Failed Login, print error message */
	else
	{
		print "Failed to login into Asterisk Manager\n";
	}
}
/* unable to open socket, print error string */
else
{
	print "error: {$errstr}\n";
}
?>
